<?php
    /*
    * Composant AjaxGalleryDropFilesFP pour Joomla! 3.x
    * Version J3.8P
    * Creation date: Mars 2017
    * Author: Fabrice4821 - www.gmapfp.org
    * Author email: webmaster@gmapfp.org
	* License GNU/GPL
    */

defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Language\LanguageHelper;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Client\ClientHelper;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Uri\Uri;

Session::checkToken();

// Reference global application object
$app = Factory::getApplication();
$input = $app->input;
// Load language file for module
$lang     = Factory::getLanguage();

$task = $input->get('task', '');
$module_id = $input->getInt('module_id', '');
if ($module_id=='') exit_upload(Text::_('COM_AJAXGALLERYDROPFILESFP_ERROR_MODULEID'));

$file_dir = 'media/mod_galleryfp/galleries/'.$module_id;
$allowed_ext = array('jpeg','jpg','png','gif','tif');

// Set FTP credentials, if given
ClientHelper::setCredentialsFromRequest('ftp');

if ($task == 'add') {

	$data_info = '';

	if(!file_exists(JPATH_ROOT.'/'.$file_dir)){
		Folder::create(JPATH_ROOT.'/'.$file_dir);
	}

	if(strtolower($_SERVER['REQUEST_METHOD']) != 'post'){            
		exit_upload(Text::_('COM_AJAXGALLERYDROPFILESFP_CTRL_FILES_WRONG_HTTP_RESPONSE'));
	}

	if(array_key_exists('photo_file',$_FILES) && $_FILES['photo_file']['error'] == 0 ){

		$fpfile = $_FILES['photo_file'];
		if(!in_array(strtolower(File::getExt($fpfile['name'])),$allowed_ext)){
			exit_upload(Text::_('COM_AJAXGALLERYDROPFILESFP_CTRL_FILES_WRONG_FILE_EXTENSION').' : '.strtolower(File::getExt($fpfile['name'])));
		}
	   
		if(!File::upload($fpfile['tmp_name'], JPATH_ROOT.'/'.$file_dir.'/'.utf8_decode(urldecode($fpfile['name'])))){
			exit_upload(Text::_('COM_AJAXGALLERYDROPFILESFP_CTRL_FILES_CANT_UPLOAD_FILE'));
		}

		$langues = LanguageHelper::createLanguageList('', constant('JPATH_SITE'), true, true);
		
		$json_name = 'json'.rtrim(strtr(base64_encode(urldecode($fpfile['name'])), '+/', '-_'), '=');
		$data_info = '<li class="picture-item" id="'.$json_name.'">';
			$data_info .= '<div class="picture-area">';
				$data_info .= '<div class="picture-info">';
					$data_info .= '<div class="picture-thumb">';
						$data_info .= '<img src="'.URI::base().'../'.$file_dir.'/'.urldecode($fpfile['name']).'"/><span onclick="delete_file(\''.urldecode($fpfile['name']).'\',\''.$json_name.'\');" class="icon-trash"></span>';
					$data_info .= '</div>';
					foreach ($langues as $langue) {
						$json_lang = str_replace('-', '_', $langue['value']);
						eval('$json_value = @$param_json->'.$json_name.'->'.$json_lang.';');
						$data_info .= '<div class="search_langue">';
							$data_info .= '<label>'.$langue['value'].'</label> <textarea name="'.$json_name.'_'.$langue['value'].'" file="'.$json_name.'" lang="'.$json_lang.'" id="'.$json_name.'_'.$langue['value'].'" onChange="update_json_value(this)">'.$json_value.'</textarea>';
						$data_info .= '</div>';
					}
				$data_info .= '</div>';
				$data_info .= '<div class="picture-name">';
					$data_info .= '<label name="files_galleryfp">'.urldecode($fpfile['name']).' </label>';
				$data_info .= '</div>';
			$data_info .= '</div>';
		$data_info .= '</li>';
		
		$json_file = '{"json'.rtrim(strtr(base64_encode(urldecode($fpfile['name'])), '+/', '-_'), '=').'": {'."\n";
		$json_name = 'json'.rtrim(strtr(base64_encode(urldecode($fpfile['name'])), '+/', '-_'), '=');
		$json_langage = array();
		foreach ($langues as $langue) {
			$json_lang = str_replace('-', '_', $langue['value']);
			eval('$json_value = @$param_json->'.$json_name.'->'.$json_lang.';');
			$json_langage[] = '"'.str_replace('-', '_', $langue['value']).'":'.'"'.$json_value.'"';
		}
		$json_file .= implode(','."\n", $json_langage);
		$json_file .= '}}';
		
		$data_info = array('content' => $data_info, 'json_data' => $json_file);
	}

	exit_upload(true, $data_info);
}

if ($task == 'add_video') {

	$video_index = $input->getString('video_index', '');

	$langues = LanguageHelper::createLanguageList('', constant('JPATH_SITE'), true, true);
		
		$json_name = 'jsonvideo'.$video_index;
		$data_info = '<li class="picture-item" id="'.$json_name.'">';
			$data_info .= '<div class="picture-area">';
				$data_info .= '<div class="picture-info">';
					$data_info .= '<div class="picture-thumb">';
						$data_info .= '<input type="text" id="'.$json_name.'_url" onchange="update_json_value(this)"><span onclick="delete_video(\''.$json_name.'\');" class="icon-trash"></span>';
					$data_info .= '</div>';
					foreach ($langues as $langue) {
						$json_lang = str_replace('-', '_', $langue['value']);
						eval('$json_value = @$param_json->'.$json_name.'->'.$json_lang.';');
						$data_info .= '<div class="search_langue">';
							$data_info .= '<label>'.$langue['value'].'</label> <textarea name="'.$json_name.'_'.$langue['value'].'" file="'.$json_name.'" lang="'.$json_lang.'" id="'.$json_name.'_'.$langue['value'].'" onChange="update_json_value(this)">'.$json_value.'</textarea>';
						$data_info .= '</div>';
					}
				$data_info .= '</div>';
				$data_info .= '<div class="picture-name">';
					$data_info .= '<label name="files_galleryfp">'.Text::sprintf('COM_AJAXGALLERYDROPFILESFP_VIDEO_URL', $video_index).'</label>';
				$data_info .= '</div>';
			$data_info .= '</div>';
		$data_info .= '</li>';
		
		$json_file = '{"'.$json_name.'": {'."\n";
		$json_name = $json_name;
		$json_langage = array();
		foreach ($langues as $langue) {
			$json_lang = str_replace('-', '_', $langue['value']);
			eval('$json_value = @$param_json->'.$json_name.'->'.$json_lang.';');
			$json_langage[] = '"'.str_replace('-', '_', $langue['value']).'":'.'"'.$json_value.'"';
		}
		$json_file .= implode(','."\n", $json_langage);
		$json_file .= '}}';
		
		$data_info = array('content' => $data_info, 'json_data' => $json_file);

	exit_upload(true, $data_info);
}

if ($task == 'delete') {
	$name = $input->getString('name', '');
	$audio_id = $input->getString('id', '');
	if (File::delete(JPATH_ROOT.'/'.$file_dir.'/'.utf8_decode($name))) {
		$json_name = 'json'.rtrim(strtr(base64_encode($name), '+/', '-_'), '=');
		exit_upload(true, $json_name);
	} else 
		exit_upload(false, $json_name);
	Factory::getApplication()->close();
}

if ($task == 'update_updatercode') {
	$data = explode(',', $input->getString('data', ''));
	
	if ($data[0]) {
		$db = Factory::getDbo();
		
		$key = preg_replace('#[^A-Za-z0-9]+#', '', $data[0]); // Ne garde que les caractères de A à Z et de a à z et de 0 à 9. Supprime les autres caractères.
		
		// Look if the location is used already; doesn't matter what type you can't have two types at the same address, doesn't make sense
		$query = $db->getQuery(true)
			->select($db->quoteName('update_site_id'))
			->from($db->quoteName('#__update_sites_extensions', 'a'))
			->join('INNER', $db->quoteName('#__extensions', 'b') . ' ON (' . $db->quoteName('a.extension_id') . ' = ' . $db->quoteName('b.extension_id') . ')')
			->where($db->quoteName('b.type') . ' = ' . $db->quote('package') . ' AND ' . $db->quoteName('b.element') . ' = ' . $db->quote('pkg_GalleryFP'));
		$db->setQuery($query);
		$update_site_id = (int) $db->loadResult();
		
		// Check if it has an update site id (creation might have faileD)
		if ($update_site_id)
		{
			// Fields to update.
			$fields = array(
				$db->quoteName('extra_query') . ' = ' . $db->quote('key='.$key)
			);

			// Conditions for which records should be updated.
			$conditions = array(
				$db->quoteName('update_site_id') . ' = ' . $db->quote($update_site_id)
			);
			
			// Link this extension to the relevant update site
			$query->clear()
				->update($db->quoteName('#__update_sites'))->set($fields)->where($conditions);
			$db->setQuery($query);
			$result = $db->execute();
			if ($result)
				exit_upload(true);
			else 
				exit_upload(false);
		}
	}
	JFactory::getApplication()->close();
}

function exit_upload($status,$datas='') {
	$response = array('response'=>$status,'datas'=>$datas);            
	echo json_encode($response);
	Factory::getApplication()->close();
}
