<?php
    /*
    * Module GalleryFP pour Joomla! 4.x
    * Version J4.0F
    * Creation date: Mai 2022
    * Author: Fabrice4821 - www.gmapfp.org
    * Author email: webmaster@gmapfp.org
	* License GNU/GPL
    */

defined('_JEXEC') or die;

use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;

JHtml::_('jquery.framework');	

//test le type de cache
$conf = Factory::getConfig();
$cache_type = $conf->get('caching');
if ($cache_type == 2) {
	echo Text::_('MOD_GALERIE_FP_NOT_COMPATIBLE_PROGRESSIVE_CACHE');
}

$id = $module->id;
$path = 'media/mod_galleryfp/';
$compurl = URI::base(). $path;
$pic = 'media/mod_galleryfp/galleries/'.$id.'/';
$images_folder = URI::base().$pic;
$images_folder = URI::base().$pic;
$images_c_folder = JPATH_BASE.'/'.$pic;
$lang = Factory::getLanguage();
$num = rand();
$numrand  = '';
$doc = Factory::getDocument();
$resize_all = false;

//test si répertoire thumb exist, sinon le créer et y mettre un fichier index.html
if (!Folder::exists($images_c_folder.'thumb/')) {
	Folder::create($images_c_folder.'thumb/');
}
//test si la taille des images principale à changer dans les paramètres
if ($params->get('redimentionner', '1') and $params->get('oldsize', '0')) {
	$params->set('oldsize', '0');
	$table = JTable::getInstance('module');
	$table->load($id);
	$table->bind(array('params' => $params->toString()));
	$table->check();
	$table->store();
	$resize_all = true;
}
//test si répertoire main exist, sinon le créer et y mettre un fichier index.html
if ($params->get('redimentionner', '1') and !Folder::exists($images_c_folder.'main'.$id.'/')) {
	Folder::create($images_c_folder.'main'.$id.'/');
}
		
//pour être sur que jQuery soit lancé avant
if (!defined('PLUG_GALLERIA') and $params->get('theme', 'classic') != 'polaroid') {
	$doc->addCustomTag( '<script type="text/javascript" src="'.$compurl.'js/galleria-1.5.7.js"></script>');
	define('PLUG_GALLERIA', true);
}
if ($params->get('Background', ''))
	echo '<style>'."\r\n".'.galleria-container, .galleria-thumbnails-container, .galleria-image, .galleria-info-text{background-color: '.$params->get('Background', '#b0b0b0').' !important;}'."\r\n".'</style>'."\r\n";
if ($params->get('thumbnails', 'true') != 'true') {
	echo '<style>'."\r\n".'.galleria-theme-classic .galleria-stage{bottom: 10px !important;}'."\r\n".'.galleria-theme-classic .galleria-thumbnails-container{height: 0px !important;}'."\r\n".'</style>'."\r\n";
}
$param_json = json_decode($params->get('commentaires_photos'));
$widh = '';
if ($params->get('largeur', ''))
	$widh = " width: ".$params->get('largeur').";";
?>
<!-- GalleryFP module de GMapFP -->
<div class="galleria_fp GalleryFP<?php echo $num; ?>" style="min-width: 200px; min-height: 40px;<?php echo $widh; ?>">
<?php
	$dirFiles = array();
	// opens images folder
	if ($handle = opendir($images_c_folder)) {
		while (false !== ($file = readdir($handle))) {
			// strips files extensions      
			$crap   = array("jpg", "jpeg", "png", "gif", "bmp");    
		   // hides folders, writes out ul of images and thumbnails from two folders
		   $extension = strtolower(substr(strrchr($file,'.'),1));
			if (in_array($extension, $crap) && $file != "." && $file != ".." && $file != "index.php" && $file != "index.html" && $file != "thumbs" && $file != "Thumbnails") {
					$dirFiles['json'.rtrim(strtr(base64_encode(utf8_encode($file)), '+/', '-_'), '=')] = $file;
					$dirFilesName[$file] = 'json'.rtrim(strtr(base64_encode(utf8_encode($file)), '+/', '-_'), '=');
			}
		}
		closedir($handle);
		ksort($dirFilesName, SORT_NATURAL | SORT_FLAG_CASE);
	}

	//nettoyage des valeurs json
	if (!empty($param_json))
		foreach ($param_json as $name => $value) {
			if (in_array($name, $dirFilesName)){
				$key = array_search($name, $dirFilesName);
				unset($dirFilesName[$key]);
			} else {
				unset($param_json->$name);
			}
		}
	else
		$param_json = new stdClass();
	
	//ajoute les nouveaux fichiers
	if (!empty($dirFilesName))
		foreach($dirFilesName as $FilesName) {
			$param_json->$FilesName = "";
		}
	
	if ($params->get('theme', 'classic') == 'polaroid') {
		foreach($param_json as  $name => $info_lang)
		{
			$is_video = property_exists($info_lang, 'url');
			$json_tag_lang = str_replace('-', '_', $lang->getTag());
			$json_value = @$info_lang->$json_tag_lang;
			if ($is_video) 
				$file = $info_lang->url;
			else 
				$file = $dirFiles[$name];
			$filename = '';
			$add_filename = $params->get('add_filename', 0);
			if ($add_filename == 1) $filename .= substr($file,0,strrpos($file,'.')).'<br/>';
			if ($add_filename == 2 && $json_value == "") $json_value .= utf8_encode(substr($file,0,strrpos($file,'.'))).'<br/>';
			$commentaires = '';
			if ($params->get('commentaire', '')) $commentaires = $params->get('commentaire', '').'<br/>';
			$main_exist = File::exists($images_c_folder.'main'.$id.'/'.$file);
			if (!$is_video and $params->get('redimentionner', '1')) {
				if (!$main_exist or $resize_all) {
					//céais la miniature
					require_once( JPATH_BASE.'/modules/mod_galleryfp/plugins/imagemagic.php' );
					$image_magic = new GMapFPImageMagic;

					if($image_magic->imageMagic($images_c_folder.$file, $images_c_folder.'main'.$id.'/'.$file, $params->get('largeur_main_image', '600'), 45, 0, null, $errorMsg)) {
						$images = $images_folder.'main'.$id.'/'.str_replace("'", "\\'", utf8_encode($file));
						$big = $images_folder.str_replace("'", "\\'", utf8_encode($file));
					}
				} else {
					$images = $images_folder.'main'.$id.'/'.str_replace("'", "\\'", utf8_encode($file));
					$big = $images_folder.str_replace("'", "\\'", utf8_encode($file));
				}
			} else {
				$images = $images_folder.str_replace("'", "\\'", utf8_encode($file));
				$big = $images_folder.str_replace("'", "\\'", utf8_encode($file));
			}
			echo '<div class="polaroid s'.$params->get('polaroide_size', '300').'">'."\n";
			if (!$is_video) {
				if ($params->get('lightbox', 'false') == 1) echo '	<a href="'.$big.'" alt="'.str_replace('"', '\\"', $filename).'" class="colorbox" title="'.str_replace('<br/>', ' / ', $commentaires.$json_value).'"/>'."\n";
				echo '		<img src="'.$images.'" alt="'.str_replace('"', '\\"', $filename).'" />'."\n";
			}
			echo '		<p>'.$commentaires.$json_value.'</p>'."\n";
			if (!$is_video and $params->get('lightbox', 'false') == 1) echo '	</a>'."\n";
			echo '</div>'."\n";
		}
	} else {
		$Json_tab = array();
		foreach($param_json as  $name => $info_lang)
		{
			$is_video = property_exists($info_lang, 'url');
			$Json_tmp = '{';
			$filename = '';
			$file = $dirFiles[$name];
			
			// $json_name = 'json'.str_replace(array('.', '-', ' '), array('ùùù', 'ààà', 'ééé'), $file);
			$json_name = 'json'.rtrim(strtr(base64_encode($file), '+/', '-_'), '=');
			$json_tag_lang = str_replace('-', '_', $lang->getTag());
			$json_value = @$info_lang->$json_tag_lang;
			$add_filename = $params->get('add_filename', 0);
			$numrand++;
			if ($add_filename == 1) $filename .= substr($file,0,strrpos($file,'.')).'<br/>';
			if ($add_filename == 2 && $json_value == "") $filename .= utf8_encode(substr($file,0,strrpos($file,'.'))).'<br/>';
			$commentaires = '';
			if ($params->get('commentaire', '')) $commentaires = $params->get('commentaire', '').'<br/>';
			if ($numrand > 2 + 4) break;
			//test si thumb et big exist
			$thumb_exist = File::exists($images_c_folder.'thumb/'.$file);
			$big_exist = File::exists($images_c_folder.'big/'.$file);
			$main_exist = File::exists($images_c_folder.'main'.$id.'/'.$file);
			
			if ($params->get('theme', 'classic') != 'folio') {
				if (!$thumb_exist) {
					//céais la miniature
					require_once( JPATH_BASE.'/modules/mod_galleryfp/plugins/imagemagic.php' );
					$image_magic = new GMapFPImageMagic;

					if($image_magic->imageMagic($images_c_folder.$file, $images_c_folder.'thumb/'.$file, 60, 45, 0, null, $errorMsg)) $Json_tmp .= "thumb: '".$images_folder.'thumb/'.str_replace("'", "\\'", utf8_encode($file))."',";
				} else
					$Json_tmp .= "thumb: '".$images_folder.'thumb/'.str_replace("'", "\\'", utf8_encode($file))."',";
			}

			if ($params->get('redimentionner', '1')) {
				if (!$main_exist or $resize_all) {
					//créais la miniature
					require_once( JPATH_BASE.'/modules/mod_galleryfp/plugins/imagemagic.php' );
					$image_magic = new GMapFPImageMagic;

					if($image_magic->imageMagic($images_c_folder.$file, $images_c_folder.'main'.$id.'/'.$file, $params->get('largeur_main_image', '600'), 45, 0, null, $errorMsg)) {
						$Json_tmp .= "image: '".$images_folder.'main'.$id.'/'.str_replace("'", "\\'", utf8_encode($file))."',";
						$Json_tmp .= "big: '".$images_folder.str_replace("'", "\\'", utf8_encode($file))."',";
					}
				} else {
					$Json_tmp .= "image: '".$images_folder.'main'.$id.'/'.str_replace("'", "\\'", utf8_encode($file))."',";
					$Json_tmp .= "big: '".$images_folder.str_replace("'", "\\'", utf8_encode($file))."',";
				}
			} else {
				$Json_tmp .= "image: '".$images_folder.str_replace("'", "\\'", utf8_encode($file))."',";
				if ($big_exist)  $Json_tmp .= "big: '".$images_folder.'big/'.str_replace("'", "\\'", utf8_encode($file))."',";
			}

			$Json_tmp .= "title: '".str_replace("'", "\\'", $commentaires.$filename)."',";
			$Json_tmp .= "description: '".str_replace("'", "\\'", $json_value)."'";
			// $Json_tmp .= "link: '".'http://gmapfp.org'."'";
			// $Json_tmp .= "layer: '".'tedt'."',";
			
			$Json_tmp .= '}';
			$Json_tab[] = $Json_tmp;
		}

		$nbre_images = count($Json_tab);
		$nbre_boucle = 0;
		$Json_data = 'var testFP;';
		
		if ($params->get('cnt_upload_pictures', 100))
			while ($nbre_images > 0) {
				$Json_data .= 'var GalleryFP_Data_'.$nbre_boucle.'_'.$num.' = ['."\n";
				$Json_data .= implode(','."\n", array_slice($Json_tab, $nbre_boucle*$params->get('cnt_upload_pictures', 100), $params->get('cnt_upload_pictures', 100)))."\n";
				$Json_data .= '];'."\n";
				
				$nbre_images = $nbre_images - $params->get('cnt_upload_pictures', 100);
				$nbre_boucle++;
			}
		else {
			$Json_data = 'var GalleryFP_Data_0_'.$num.' = ['."\n";
			$Json_data .= implode(','."\n", $Json_tab)."\n";
			$Json_data .= '];'."\n";
			$nbre_boucle++;
		}
		
		$doc->addScriptDeclaration($Json_data);
	}
?>
</div>
<?php
$html = '<div class="galleryfp_copyright">';
$link = @file_get_contents('http://www.gmapfp.org/link.txt');
if ($link) {
	$link = explode("\n", $link);
	$html .= '<div style="text-align:center;">';
	$html .= Text::_('MOD_GALERIE_FP_SPONSOR_LINK').'<a href="'.$link[1].'" target="_blank">'.$link[0].'</a>';
	$html .= '</div>';
}
$html .= '<div style="text-align:center;">';
$html .= '<a href="http://gmapfp.org" target="_blank">GMapFP</a> : '.Text::_('MOD_GALERIE_FP_COPYRIGHT');
$html .= '</div></div>';
echo $html;
if ($params->get('theme', 'classic') != 'polaroid')
{
	//option
	switch ($params->get('thumbcrop', 'true')) {
		case 'true':
			$thumbCrop = 'true';
			break;
		case 'false':
			$thumbCrop = 'false';
			break;
		case 'height':
			$thumbCrop = '"height"';
			break;
		case 'width':
			$thumbCrop = '"width"';
			break;
	};
	switch ($params->get('imageCrop', 'true')) {
		case 'true':
			$imageCrop = 'true';
			break;
		case 'false':
			$imageCrop = 'false';
			break;
		case 'height':
			$imageCrop = '"height"';
			break;
		case 'width':
			$imageCrop = '"width"';
			break;
	};
	if ($params->get('theme', 'classic')=='twelve')
		$_showTooltip = $params->get('twelve_showTooltip', 'true');
	else
		$_showTooltip = $params->get('azur_showCaption', 'true');
	if ($params->get('autoplay', 'false') != 'false')
		$autoplay = $params->get('autoplayspeed', '5000');
	else
		$autoplay = 'false';
		
	$options_communes = '
		_locale: {
			show_captions: "'.Text::_('MOD_GALERIE_FP_SHOW_CAPTION').'",
			hide_captions: "'.Text::_('MOD_GALERIE_FP_HIDE_CAPTION').'",
			next: "'.Text::_('MOD_GALERIE_FP_NEXT').'",
			prev: "'.Text::_('MOD_GALERIE_FP_PREVIEW').'",
			show_thumbnails: "'.Text::_('MOD_GALERIE_FP_SHOW_THUMBNAILS').'",
			hide_thumbnails: "'.Text::_('MOD_GALERIE_FP_HIDE_THUMBNAILS').'",
			play: "'.Text::_('MOD_GALERIE_FP_PLAY').'",
			pause: "'.Text::_('MOD_GALERIE_FP_PAUSE').'",
			enter_fullscreen: "'.Text::_('MOD_GALERIE_FP_ENTER_FULLSCREEN').'",
			exit_fullscreen: "'.Text::_('MOD_GALERIE_FP_EXIT_FULLSCREEN').'",
			popout_image: "'.Text::_('MOD_GALERIE_FP_POPOUT_IMAGE').'",
			show_info: "'.Text::_('MOD_GALERIE_FP_INFO').'",
			showing_image: "'.Text::_('MOD_GALERIE_FP_SHOWING_IMAGE').'"
		}
	';
	
	$options = '
			num: '.$num.',
			lightbox: '.$params->get('lightbox', 'false').',
			wait: true,
			overlayBackground: "'.$params->get('overlayBackground', '#b0b0b0').'",
			responsive: '.$params->get('responive', 'true').',
			trueFullscreen: '.$params->get('trueFullscreen', 'true').',
			transition: "'.$params->get('transition', 'pulse').'",
			transitionSpeed: "'.$params->get('transitionSpeed', '1000').'",
			thumbCrop: '.$thumbCrop.',
			imageCrop: '.$imageCrop.',
			pauseOnInteraction: '.$params->get('pauseOnInteraction', 'false').',
			carousel: '.$params->get('carousel', 'true').',
			imagePan: '.$params->get('imagePan', 'true').',
			clicknext: '.$params->get('clicknext', 'true').',
			autoplay: '.$autoplay.',
			showImagenav: '.$params->get('showImagenav', 'false').',
			showInfo: '.$params->get('showInfo', 'true').',
			showCounter: '.$params->get('showCounter', 'true').',
			thumbnails: '.$params->get('thumbnails', 'true').',
			_showFullscreen: '.$params->get('twelve_showFullscreen', 'true').',
			_showPopout: '.$params->get('twelve_showPopout', 'true').',
			_showProgress: '.$params->get('twelve_showProgress', 'true').',
			_showTooltip: '.$_showTooltip.',
			_webkitCursor: '.$params->get('folio_webkitCursor', 'true').',
			_animate: '.$params->get('folio_animate', 'true').',
			_center: '.$params->get('folio_center', 'true').',
			_hideDock: '.$params->get('fullscreen_hideDock', 'true').',
			_toggleCaption: '.$params->get('azur_toggleCaption', 'true').',
			_showCaption: '.$params->get('azur_showCaption', 'true').',
	';

	$theme = $params->get('theme', 'classic');
	// affichage classic sans la bande des miniatures
	// if (($params->get('theme', 'classic') == 'classic') and ($params->get('thumbnails', 'true') != 'true')) $theme = 'classic2';

	?>
	<script type="text/javascript">
		Galleria.configure({
			<?php echo $options_communes;?>
		});
		
		var nbre_boucle_<?php echo $num; ?> = <?php echo $nbre_boucle; ?>;
		var gallery<?php echo $num; ?>;
		var interval_<?php echo $num; ?> = null;
		var boucle_<?php echo $num; ?> = 1;
		var galleries_ready = new Array();
		
	// Initialize Gallerie
	   Galleria.loadTheme('<?php echo $compurl; ?>themes/<?php echo $params->get('theme', 'classic'); ?>/galleria.<?php echo $theme; ?>.min.js');
	   Galleria.run('.GalleryFP<?php echo $num; ?>', {
			theme: '<?php echo $params->get('theme', 'classic'); ?>',
			height: <?php echo $params->get('proportion', '0.5625'); ?>,
			dataSource: GalleryFP_Data_0_<?php echo $num; ?>,
			<?php echo $options;?>
		});
		Galleria.ready(function(options){
			if(galleries_ready.indexOf(options.num) == -1) {
				gallery<?php echo $num; ?> = this;
				interval_<?php echo $num; ?> = setInterval(load_<?php echo $num; ?>, <?php echo $params->get('cnt_upload_time', 1000); ?>);
				galleries_ready.push(options.num);
			}
		});
		function load_<?php echo $num; ?>()
		{
			tmp = eval('GalleryFP_Data_'+(boucle_<?php echo $num; ?>-1)+'_<?php echo $num; ?>');
			gallery<?php echo $num; ?>.push(tmp);
			boucle_<?php echo $num; ?>++;
			if (boucle_<?php echo $num; ?> >= nbre_boucle_<?php echo $num; ?>) {
				clearInterval(interval_<?php echo $num; ?>);
				// gallery<?php echo $num; ?>.lazyLoadChunks(3, 10);
			}
		}
	</script> 
	<!-- End GalleryFP module -->
	<?php
} else {
	$doc->addScript('http://www.google.com/jsapi');
	if ($params->get('theme', 'classic') == 'polaroid') {
		$doc->addScript($compurl.'themes/'.$params->get('theme', 'classic').'/jquery.colorbox-min.js');
		$doc->addStyleSheet($compurl.'themes/'.$params->get('theme', 'classic').'/colorbox.css');
	}
	$doc->addScript($compurl.'themes/'.$params->get('theme', 'classic').'/'.$params->get('theme', 'classic').'.js');
	$doc->addStyleSheet($compurl.'themes/'.$params->get('theme', 'classic').'/'.$params->get('theme', 'classic').'.css');
}