<?php
    /*
    * Module GalleryFP pour Joomla! 3.x
    * Version J3.33P
    * Creation date: Septembre 2019
    * Author: Fabrice4821 - www.gmapfp.org
    * Author email: webmaster@gmapfp.org
	* License GNU/GPL
    */

namespace Joomla\Module\Galleryfp\Site\Field;

\defined('JPATH_PLATFORM') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Filesystem\File;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Form\FormField;

class FilescommentsField extends FormField
{
	protected $type = 'Filescomments';


	protected function getInput()
	{
		if ($this->form instanceof Form)
		{
			$doc 		= Factory::getDocument();
			$langues 	= HTMLHelper::_('contentlanguage.existing');

			// Définition de JUri::base() sans tenir compte du paramètre $config->get('live_site') de la config principale
			$uri 		= Uri::getInstance();
			$base['prefix'] = $uri->toString(array('scheme', 'host', 'port'));
			if (strpos(php_sapi_name(), 'cgi') !== false && !ini_get('cgi.fix_pathinfo') && !empty($_SERVER['REQUEST_URI']))
				$script_name = $_SERVER['PHP_SELF'];
			else $script_name = $_SERVER['SCRIPT_NAME'];
			$base['path'] = rtrim(dirname($script_name), '/\\');
			$Base_URL = $base['prefix'] . $base['path'] . '/';
			$Base_URL = substr($Base_URL, 0, -14);
			$module_id = $this->form->getValue('id');
			$files_dir = 'media/mod_galleryfp/galleries/'.$module_id;
			if (!$module_id) {
				echo '<div class="alert">'.Text::_('MOD_GALLERYFP_SAVE_BEFORE').'</div>';
				return;
			}

			$max_size = $post_max_size = (int)ini_get('post_max_size');
			$upload_max_filesize = (int)ini_get('upload_max_filesize');
			if($post_max_size > $upload_max_filesize) $max_size = $upload_max_filesize;
			$max_file_uploads  = (int)ini_get('max_file_uploads');
			$doc->addScriptDeclaration('var max_upload_size = '.$max_size.';');

			HTMLHelper::_('stylesheet', $Base_URL.'modules/mod_galleryfp/assets/css/filescomments.css', array('version'=>'auto')); 
			HTMLHelper::_('stylesheet', $Base_URL.'modules/mod_galleryfp/assets/jquery-ui-1.13/jquery-ui.css');
			HTMLHelper::_('script', $Base_URL.'modules/mod_galleryfp/assets/jquery-ui-1.13/jquery-ui.js');
			HTMLHelper::_('script', $Base_URL.'modules/mod_galleryfp/assets/js/bootbox.min.js');
			HTMLHelper::_('script', $Base_URL.'modules/mod_galleryfp/assets/js/jquery.md5.js');
			HTMLHelper::_('script', $Base_URL.'modules/mod_galleryfp/assets/js/admin-pages.js', array('version'=>'auto'));
			HTMLHelper::_('bootstrap.renderModal'); //pour bootbox
			
			Text::script('MOD_GALLERYFP_FILE_TOO_LARGE');

			$video_index = 0;

			
	?>
			<div class="row">
				<div class="add_photos_area col-lg-3">
					<div id="drag_photos_fp">
						<div id="upload_message">
							<span class="message"><?php echo Text::_('MOD_GALLERYFP_DROP_FILE');?></span>
							<input hidden="hidden" id="upload_photofp_input" name="photo_file" multiple="" type="file">
							<a href="" id="upload_photofp_button" class="btn btn-large btn-primary"><?php echo Text::_('MOD_GALLERYFP_DROP_FILE_BP');?></a>
						</div>
					</div>
					<div id="drag_videos_fp">
						<div id="upload_videos_message">
							<span class="message"><?php echo Text::_('MOD_GALERIE_FP_ADD_VIDEO');?></span>
							<a href="" id="add_video_button" class="btn btn-large btn-primary"><?php echo Text::_('MOD_GALERIE_FP_ADD_VIDEO_BP');?></a>
						</div>
					</div>
				</div>
				<div class="add_photos_area col-lg-9">
	<?php
					echo '<div id="mes_photos_fp">';

						echo '<strong>'.Text::_($this->element['label']).'</strong> : '.Text::_($this->element['description']);
						
						$param_json = json_decode($this->value);
						if (empty($files_dir)) return;
						$pic = $files_dir."/";

						$dirFiles = array();
						$dirFilesName = array();
						// opens images folder
						if ($handle = @opendir(JPATH_ROOT.'/'.$pic)) {
							while (false !== ($file = readdir($handle))) {
								// strips files extensions      
								$crap   = array(".jpg", ".jpeg", ".png", ".gif", ".bmp");
								$extension = substr($file, strrpos($file, '.'));
							   // hides folders, writes out ul of images and thumbnails from two folders
								if (in_array(strtolower($extension), $crap) && $file != "." && $file != ".." && $file != "index.php" && $file != "index.html" && $file != "thumbs" && $file != "Thumbnails") {
										$dirFiles['json'.rtrim(strtr(base64_encode(utf8_encode($file)), '+/', '-_'), '=')] = $file;
										$dirFilesName[] = 'json'.rtrim(strtr(base64_encode(utf8_encode($file)), '+/', '-_'), '=');
								}
							}
							closedir($handle);
						}
						
					//test la cohérence entre les photos du répertoire et les données en table
						$values = json_decode($this->value);

						//nettoyage des valeurs json
						if (!empty($values))
							foreach ($values as $name => $value) {
								if (in_array($name, $dirFilesName)){
									$key = array_search($name, $dirFilesName);
									unset($dirFilesName[$key]);
								} else if (substr($name, 0, 9) != 'jsonvideo') {
									unset($values->$name);
								}
							}
						if (empty($values)) $values = new \stdclass();
						
						//ajoute les nouveaux fichiers
						if (!empty($dirFilesName))
							foreach($dirFilesName as $FilesName) {
								$langage = new \stdClass();
								foreach ($langues as $langue) {
									$json_name = str_replace('-', '_', $langue->value);
									$langage->$json_name = '';
								}
								$values->$FilesName = $langage;
							}
						
						//construction du json
						$json = "\n".' <script type="text/javascript">'."\n".'var FPGallery_photo = '."\n";
						$json .= json_encode($values);
						$json .= ';'."\n".'</script>'."\n";
						echo $json;
						echo '<ul id="sortable" class="liste_pitures">';
					// Affiche dans l'ordre de tri les images;
						if (!empty($values))
							foreach ($values as $name => $value) {
								if (substr($name, 0, 9) == 'jsonvideo') {
									$is_video = true;
									if ($video_index < substr($name, 9)) $video_index = substr($name, 9);
								} else {
									$is_video = false;
									$file = $dirFiles[$name];
								}
								echo '<li class="picture-item" id="'.$name.'">';
									echo '<div class="picture-area">';
										echo '<div class="picture-info">';
											echo '<div class="picture-thumb">';
												if ($is_video) {
													echo '<input type="text" id="'.$name.'_url" value="'.$value->url.'" onchange="update_json_value(this)"><span onclick="delete_video(\''.$name.'\')" class="icon-trash"></span>';
												} else {
													if (file_exists(JPATH_ROOT.'/'.$pic.'thumb/'.utf8_encode($file)))
														echo '<img src="'.URI::base().'../'.$pic.'thumb/'.utf8_encode($file).'"/><span onclick="delete_file(\''.utf8_encode($file).'\',\''.$name.'\');" class="delete-button icon-trash"></span>';
													else
														echo '<img src="'.URI::base().'../'.$pic.utf8_encode($file).'"/><span onclick="delete_file(\''.utf8_encode($file).'\',\''.$name.'\');" class="delete-button icon-trash"></span>';
												}
											echo '</div>';
											foreach ($langues as $langue) {
												$lang = str_replace('-', '_', $langue->value);
												eval('$json_value = @$param_json->'.$name.'->'.$lang.';');
												echo '<div class="search_langue">';
													echo '<label>'.$langue->value.'</label> <textarea name="'.$name.'_'.$langue->value.'" id="'.$name.'_'.$langue->value.'" onChange="update_json_value(this)">'.$json_value.'</textarea>';
												echo '</div>';
											}
										echo '</div>';
										echo '<div class="picture-name">';
											if ($is_video) {
												echo '<label name="files_galleryfp">URL</label>';
											} else {
												echo '<label name="files_galleryfp">'.utf8_encode($file).' </label>';
											}
										echo '</div>';
									echo '</div>';
								echo '</li>';
							}
						echo '</ul>';

						echo '<textarea style="display:none;" name="'.$this->name.'" id="' . $this->id . '"" >'.$this->value.'</textarea>';
					echo '</div>'; //fermeture de dropzone
					$doc->addScriptDeclaration("var video_index = $video_index;");
				echo '</div>';
			echo '</div>';
		}
		else return;
	}
	public function getLabel() {
		 return '';
	}
}